<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: modelo_llamadas_nhc_5.xml */
/* Generado: 2014-11-25 12:54:18 */

/* Mantenimiento de los registros de la tabla cr_llamada_cabecera */
abstract class BaseCr_llamada_cabeceraDP extends Cr_llamada_cabeceraBN
{
    /* Constructor ( Establece los valores desde un objeto Cr_llamada_cabeceraBN ) */
    public function __construct( Cr_llamada_cabeceraBN $o_Cr_llamada_cabeceraBN = null )
    {
        //parent::__construct();
        if ( !is_null( $o_Cr_llamada_cabeceraBN ) )
        {
            $this->setByBN( $o_Cr_llamada_cabeceraBN );
        }
    }

    /* Establece los valores desde un objeto Cr_llamada_cabeceraBN */
    public function setByBN( Cr_llamada_cabeceraBN $o_Cr_llamada_cabeceraBN )
    {
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getIdCabecera() ) )
        {
            $this->setIdCabecera( $o_Cr_llamada_cabeceraBN->getIdCabecera() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaTraslado() ) )
        {
            $this->setFechaTraslado( $o_Cr_llamada_cabeceraBN->getFechaTraslado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getTipoPrestamo() ) )
        {
            $this->setTipoPrestamo( $o_Cr_llamada_cabeceraBN->getTipoPrestamo() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getNumeroPrestamo() ) )
        {
            $this->setNumeroPrestamo( $o_Cr_llamada_cabeceraBN->getNumeroPrestamo() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getEstado() ) )
        {
            $this->setEstado( $o_Cr_llamada_cabeceraBN->getEstado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getIdCliente() ) )
        {
            $this->setIdCliente( $o_Cr_llamada_cabeceraBN->getIdCliente() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getNombreCliente() ) )
        {
            $this->setNombreCliente( $o_Cr_llamada_cabeceraBN->getNombreCliente() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_Cr_llamada_cabeceraBN->getFechaRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_Cr_llamada_cabeceraBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getEliminado() ) )
        {
            $this->setEliminado( $o_Cr_llamada_cabeceraBN->getEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getUsuarioEliminado() ) )
        {
            $this->setUsuarioEliminado( $o_Cr_llamada_cabeceraBN->getUsuarioEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getFechaEliminado() ) )
        {
            $this->setFechaEliminado( $o_Cr_llamada_cabeceraBN->getFechaEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getIdMercado() ) )
        {
            $this->setIdMercado( $o_Cr_llamada_cabeceraBN->getIdMercado() );
        }
        if ( !is_null( $o_Cr_llamada_cabeceraBN->getNombreMercado() ) )
        {
            $this->setNombreMercado( $o_Cr_llamada_cabeceraBN->getNombreMercado() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        //$this->validateRecord();
        $o_cr_llamada_cabeceraFN = new Cr_llamada_cabeceraFN();
        $o_cr_llamada_cabeceraBN = $o_cr_llamada_cabeceraFN->selectByPk( $this->getIdCabecera() );
        if ( is_null( $o_cr_llamada_cabeceraBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO cr_llamada_cabecera ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCabecera() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCabecera";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCabecera()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaTraslado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaTraslado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaTraslado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoPrestamo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoPrestamo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoPrestamo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroPrestamo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroPrestamo";
                $s_SQLQuery2 .= $s_Separator."".$this->getNumeroPrestamo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCliente() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCliente";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCliente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCliente() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreCliente";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreCliente()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Eliminado";
                $s_SQLQuery2 .= $s_Separator."".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMercado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdMercado";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdMercado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreMercado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreMercado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreMercado()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = $o_cr_llamada_cabeceraFN->getConnect();
            $o_Result = mysql_query( $s_SQLQuery, $o_Resource );
            if ( $o_Result === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        //$this->validateRecord();
        $o_cr_llamada_cabeceraFN = new Cr_llamada_cabeceraFN();
        $o_cr_llamada_cabeceraBN = $o_cr_llamada_cabeceraFN->selectByPk( $this->getIdCabecera() );
        if ( !is_null( $o_cr_llamada_cabeceraBN ) )
        {
            $s_SQLQuery = "UPDATE cr_llamada_cabecera SET ";
            $s_Separator = "";
            if ( !is_null( $this->getFechaTraslado() ) && $this->getFechaTraslado() !== $o_cr_llamada_cabeceraBN->getFechaTraslado() )
            {
                $s_SQLQuery .= $s_Separator."FechaTraslado = '".$this->getFechaTraslado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoPrestamo() ) && $this->getTipoPrestamo() !== $o_cr_llamada_cabeceraBN->getTipoPrestamo() )
            {
                $s_SQLQuery .= $s_Separator."TipoPrestamo = '".$this->getTipoPrestamo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroPrestamo() ) && $this->getNumeroPrestamo() !== $o_cr_llamada_cabeceraBN->getNumeroPrestamo() )
            {
                $s_SQLQuery .= $s_Separator."NumeroPrestamo = ".$this->getNumeroPrestamo()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) && $this->getEstado() !== $o_cr_llamada_cabeceraBN->getEstado() )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCliente() ) && $this->getIdCliente() !== $o_cr_llamada_cabeceraBN->getIdCliente() )
            {
                $s_SQLQuery .= $s_Separator."IdCliente = ".$this->getIdCliente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCliente() ) && $this->getNombreCliente() !== $o_cr_llamada_cabeceraBN->getNombreCliente() )
            {
                $s_SQLQuery .= $s_Separator."NombreCliente = '".$this->getNombreCliente()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) && $this->getFechaRegistro() !== $o_cr_llamada_cabeceraBN->getFechaRegistro() )
            {
                $s_SQLQuery .= $s_Separator."FechaRegistro = '".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) && $this->getUsuarioRegistro() !== $o_cr_llamada_cabeceraBN->getUsuarioRegistro() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioRegistro = '".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) && $this->getEliminado() !== $o_cr_llamada_cabeceraBN->getEliminado() )
            {
                $s_SQLQuery .= $s_Separator."Eliminado = ".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) && $this->getUsuarioEliminado() !== $o_cr_llamada_cabeceraBN->getUsuarioEliminado() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioEliminado = '".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) && $this->getFechaEliminado() !== $o_cr_llamada_cabeceraBN->getFechaEliminado() )
            {
                $s_SQLQuery .= $s_Separator."FechaEliminado = '".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdMercado() ) && $this->getIdMercado() !== $o_cr_llamada_cabeceraBN->getIdMercado() )
            {
                $s_SQLQuery .= $s_Separator."IdMercado = ".$this->getIdMercado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreMercado() ) && $this->getNombreMercado() !== $o_cr_llamada_cabeceraBN->getNombreMercado() )
            {
                $s_SQLQuery .= $s_Separator."NombreMercado = '".$this->getNombreMercado()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdCabecera = ".$this->getIdCabecera().";";
            $o_Resource = $o_cr_llamada_cabeceraFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $o_cr_llamada_cabeceraFN = new Cr_llamada_cabeceraFN();
        $o_cr_llamada_cabeceraBN = $o_cr_llamada_cabeceraFN->selectByPk( $this->getIdCabecera() );
        if ( !is_null( $o_cr_llamada_cabeceraBN ) )
        {
            $s_SQLQuery = "DELETE FROM cr_llamada_cabecera WHERE  IdCabecera = ".$this->getIdCabecera().";";
            $o_Resource = $o_cr_llamada_cabeceraFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Selecciona un registro por la llave primaria */
    public static function selectByPk( $i_IdCabecera )
    {
        $o_cr_llamada_cabeceraFN = new Cr_llamada_cabeceraFN();
        if ( $o_cr_llamada_cabeceraBN = $o_cr_llamada_cabeceraFN->selectByPK( $i_IdCabecera ) )
        {
            $o_cr_llamada_cabeceraDP = new cr_llamada_cabeceraDP();
            $o_cr_llamada_cabeceraDP->setIdCabecera( $o_cr_llamada_cabeceraBN->getIdCabecera(), false );
            $o_cr_llamada_cabeceraDP->setFechaTraslado( $o_cr_llamada_cabeceraBN->getFechaTraslado(), false );
            $o_cr_llamada_cabeceraDP->setTipoPrestamo( $o_cr_llamada_cabeceraBN->getTipoPrestamo(), false );
            $o_cr_llamada_cabeceraDP->setNumeroPrestamo( $o_cr_llamada_cabeceraBN->getNumeroPrestamo(), false );
            $o_cr_llamada_cabeceraDP->setEstado( $o_cr_llamada_cabeceraBN->getEstado(), false );
            $o_cr_llamada_cabeceraDP->setIdCliente( $o_cr_llamada_cabeceraBN->getIdCliente(), false );
            $o_cr_llamada_cabeceraDP->setNombreCliente( $o_cr_llamada_cabeceraBN->getNombreCliente(), false );
            $o_cr_llamada_cabeceraDP->setFechaRegistro( $o_cr_llamada_cabeceraBN->getFechaRegistro(), false );
            $o_cr_llamada_cabeceraDP->setUsuarioRegistro( $o_cr_llamada_cabeceraBN->getUsuarioRegistro(), false );
            $o_cr_llamada_cabeceraDP->setEliminado( $o_cr_llamada_cabeceraBN->getEliminado(), false );
            $o_cr_llamada_cabeceraDP->setUsuarioEliminado( $o_cr_llamada_cabeceraBN->getUsuarioEliminado(), false );
            $o_cr_llamada_cabeceraDP->setFechaEliminado( $o_cr_llamada_cabeceraBN->getFechaEliminado(), false );
            $o_cr_llamada_cabeceraDP->setIdMercado( $o_cr_llamada_cabeceraBN->getIdMercado(), false );
            $o_cr_llamada_cabeceraDP->setNombreMercado( $o_cr_llamada_cabeceraBN->getNombreMercado(), false );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return $o_cr_llamada_cabeceraDP;
    }
}
?>